var x{1..4}, binary;        # l'utilisation de chaque valise 
var y{1..4,1..5}, binary;   # la matrice écrite sur le sujet
var p1;
var p2;
param cap{1..4}, integer;   # la capacité=coût de chaque valise
param poids{1..5}, integer; # les poids de chaque article
minimize obj: sum{i in 1..4}cap[i]*x[i];                #capacité=coût: 20 ou 30
s.t. colonne{j in 1..5}: sum{i in 1..4} y[i,j] = 1;     #emballer chaque article dans une valise
s.t. ligne{i in 1..4}: sum{j in 1..5}poids[j]*y[i,j]<=cap[i]*x[i]; #ne pas dépasser le poids de chaque valise utilisée
s.t. poids_passager_1: p1 == x[1]*cap[1]+x[2]*cap[2];
s.t. poids_passager_2: p2 == x[3]*cap[3]+x[4]*cap[4];
s.t. contrainte_valeur_abs1: p1-p2<=10;
s.t. contrainte_valeur_abs2: p2-p1<=10;
solve;
printf "\n=========\n";
printf "obj=%g\n", obj;
printf "obj=%g\n", p1;
printf "obj=%g\n", p2;
for{i in 1..4}{printf "Valise[%d] = %d \n", i, x[i] ; } 
for{i in 1..4}{
    for{j in 1..5}{
        printf "%d   ", y[i,j];
    }
    printf "\n";
}
data;
param cap:= 1 20
            2 30
            3 20
            4 30;
param poids:=  1 8   
               2 15    
               3 9    
               4 7   
               5 1;
end;

